## opentoonz-dmo 1.7.1

=== toonz/sources/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_BUILD_TYPE_INIT Release)

project(OpenToonz)


#-----------------------------------------------------------------------------
# Platform Specific Defaults

# list of var-names
set(_init_vars)

#-----------------------------------------------------------------------------
# Select build target
set(BUILD_TARGET_WIN       OFF)
set(BUILD_TARGET_APPLE     OFF)
set(BUILD_TARGET_UNIX      OFF)
if(WIN32)
    set(BUILD_TARGET_WIN    ON)
    message(STATUS "Target system is WIN")
elseif(APPLE)
    set(BUILD_TARGET_APPLE  ON)
    message(STATUS "Target system is APPLE")
elseif(UNIX)
    set(BUILD_TARGET_UNIX   ON)
    message(STATUS "Target system is UNIX")
else()
    set(BUILD_TARGET_UNIX   ON)
    message(WARNING "Target system unknown, set UNIX by default")
    message(STATUS "Target system is UNIX (actually unknown)")
endif()

#-----------------------------------------------------------------------------
# Select build environment

set(BUILD_ENV_MSVC     OFF)
set(BUILD_ENV_APPLE    OFF)
set(BUILD_ENV_UNIXLIKE OFF)
if(MSVC)
    set(BUILD_ENV_MSVC ON)
    if(NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is MSVC, but target system is not WIN")
    endif()
    message(STATUS "Build environment is MSVC")
elseif(CMAKE_HOST_APPLE)
    set(BUILD_ENV_APPLE ON)
    if(NOT BUILD_TARGET_APPLE)
        message(WARNING "Build environment is APPLE, but target system is not APPLE")
    endif()
    message(STATUS "Build environment is APPLE")
elseif(CMAKE_HOST_UNIX OR CMAKE_COMPILER_IS_GNUCC)
    set(BUILD_ENV_UNIXLIKE ON)
    if(NOT BUILD_TARGET_UNIX AND NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is UNIXLIKE, but target system is not UNIX or WIN")
    endif()
    message(STATUS "Build environment is UNIXLIKE")
else()
    message(ERROR "Unsupported build environment, only MSVC, APPLE and UNIXLIKE are supported")
endif()


# initialize to ON
macro(option_defaults_init)
    foreach(_var ${ARGV})
        set(${_var} ON)
        list(APPEND _init_vars "${_var}")
    endforeach()
    unset(_var)
endmacro()

# remove from namespace
macro(option_defaults_clear)
    foreach(_var ${_init_vars})
        unset(${_var})
    endforeach()
    unset(_var)
    unset(_init_vars)
endmacro()

# values to initialize WITH_****
option_defaults_init(
    _init_SYSTEM_LZO
)

# customize...
if(BUILD_ENV_MSVC)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_APPLE)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_UNIXLIKE)
    set(_init_SYSTEM_LZO                     ON)
    set(_init_SYSTEM_SUPERLU                 ON)
endif()


#-----------------------------------------------------------------------------
# Build Options

option(WITH_SYSTEM_LZO "Use the system LZO library instead of 'thirdpary'" ${_init_SYSTEM_LZO})
option(WITH_SYSTEM_SUPERLU "Use the system SuperLU library instead of 'thirdpary'" ${_init_SYSTEM_SUPERLU})
option(WITH_CANON "Build with Canon DSLR support - Requires Canon SDK" OFF)
option(WITH_TRANSLATION "Generate translation projects as well" ON)
option(WITH_WINTAB "(Windows only) Build with customized Qt with WinTab support. https://github.com/shun-iwasawa/qt5/releases/tag/v5.15.2_wintab" OFF)

# avoid using again
option_defaults_clear()

# end option(...)

#-----------------------------------------------------------------------------
# Platform Architecture

if(BUILD_ENV_APPLE)
    if(NOT PLATFORM)
        set(PLATFORM 64)
    endif()
else() # Windows and Linux case
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(PLATFORM 32)
        set(PLATFORM2)
    else()
        message("Warning : CMAKE_SIZEOF_VOID_P = ${CMAKE_SIZEOF_VOID_P}")
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    endif()
endif()
message("PLATFORM:" ${PLATFORM})

#-----------------------------------------------------------------------------
# Third Party & System Libs

include(${CMAKE_SOURCE_DIR}/../cmake/util_compiler.cmake)

get_filename_component(SDKROOT ../../thirdparty/ ABSOLUTE)
message(STATUS "SDK Root:" ${SDKROOT})
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../cmake")
if(BUILD_ENV_APPLE)
    set(THIRDPARTY_LIBS_HINTS "/usr/local/Cellar/" "/opt/include" ${SDKROOT})
elseif(BUILD_ENV_MSVC OR BUILD_ENV_UNIXLIKE)
    set(THIRDPARTY_LIBS_HINTS ${SDKROOT})
endif()

message(STATUS "Thirdpary Library Search path:" ${THIRDPARTY_LIBS_HINTS})

if(BUILD_ENV_MSVC)
    set(QT_PATH "C:/Qt/5.15.2/msvc2019${PLATFORM2}" CACHE PATH "Qt installation directory")
    if(NOT EXISTS ${QT_PATH})
        message("Specify QT_PATH properly")
        return()
    endif()
    set(QT_LIB_PATH ${QT_PATH})
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_PATH}/lib/cmake/")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4251")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251")
    add_definitions(
        -DVC_EXTRALEAN
        -DNOMINMAX
        -D_USE_MATH_DEFINES
    )
elseif(BUILD_ENV_APPLE)
    set(QT_PATH "~/Qt5.9.2/5.9.2/clang_${PLATFORM}/lib" CACHE PATH "Qt installation directory")
    set(QT_LIB_PATH "${QT_PATH}/")
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_LIB_PATH}cmake/")
    foreach(path ${CMAKE_PREFIX_PATH})
      message("CMAKE_PREFIX_PATH: " ${path})
    endforeach(path)
    add_definitions(
        -DMACOSX
        -Di386
        -D__MACOS__
    )
    if(PLATFORM EQUAL 64)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -std=c++11 -stdlib=libc++ -fno-implicit-templates")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
    elseif(PLATFORM EQUAL 32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32 -std=c++11 -stdlib=libc++ -fno-implicit-templates -D HAS_QUICKDRAW")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
        set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -m32")
    else()
        message(FATAL_ERROR "Invalid PLATFORM:" ${PLATFORM} ". 'PLATFORM' must be 32 or 64.")
    endif()
elseif(BUILD_ENV_UNIXLIKE)
    # Needed for correct Qt detection
    cmake_minimum_required(VERSION 2.8.12)
    set(PRELOAD_VARIABLE "LD_LIBRARY_PATH")
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        add_definitions(-DLINUX)
    elseif(CMAKE_SYSTEM_NAME MATCHES "Haiku")
        add_definitions(-DHAIKU)
        set(PRELOAD_VARIABLE "LIBRARY_PATH")
    elseif(CMAKE_SYSTEM_NAME MATCHES "^.*BSD$|DragonFly")
        set(BUILD_TARGET_BSD ON)
        add_definitions(-D_BSD_SOURCE -DFREEBSD)
        include_directories("/usr/local/include/")
        message(STATUS "Configuring for BSD system")
    elseif(NOT BUILD_TARGET_WIN)
        message(WARNING "Support for generic Unix (Not Apple or Linux) isn't yet working!")
    endif()

    set(CMAKE_CXX_STANDARD 11)

    find_package(Qt5Widgets)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    if (NOT (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -lstdc++")
    endif()
endif()

add_definitions(
    -DQT_GUI_LIB
    -DQT_NETWORK_LIB
    -DQT_CORE_LIB
    -DQT_SHARED
)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_ENV_APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH ${QT_LIB_PATH})
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    set(CMAKE_FIND_FRAMEWORK LAST)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${QT_LIB_PATH}" isSystemDir)
    if("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${QT_LIB_PATH}")
    endif()
endif()

include_directories(
    include
)

# Find the QtWidgets library
find_package(Qt5 REQUIRED
    Core
    Gui
    Network
    OpenGL
    Svg
    Xml
    Script
    Widgets
    PrintSupport
    LinguistTools
    Multimedia
    MultimediaWidgets
    SerialPort
    UiTools
)

set(QT_MINIMUM_VERSION 5.5.0)
if(Qt5Core_VERSION VERSION_LESS QT_MINIMUM_VERSION)
    MESSAGE(FATAL_ERROR "Minimum supported Qt version: ${QT_MINIMUM_VERSION}.
    Installed version: ${Qt5Core_VERSION}")
endif()
unset(QT_MINIMUM_VERSION)

if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/glut/3.7.6/include
        ${SDKROOT}/zlib-1.2.8
        #${SDKROOT}/LibJPEG/jpeg-9
        ${SDKROOT}/libjpeg-turbo/include
    )
    add_definitions(
        -DGLUT_NO_LIB_PRAGMA
    )
endif()


if(PLATFORM EQUAL 64)
    if(BUILD_ENV_UNIXLIKE)
        find_package(OpenCV REQUIRED)
    else() # Windows and MacOS case
        find_package(OpenCV 4.1 REQUIRED)
    endif()
    #include_directories(
    #    ${SDKROOT}/libjpeg-turbo64/include
    #)
    if(WITH_CANON)
        include_directories(
            ${SDKROOT}/canon/Header
        )
    endif()
endif()

get_target_property(QtCore_location Qt5::Core LOCATION)
get_target_property(QtWidget_location Qt5::Widgets LOCATION)
message(STATUS "Qt Core Location:" ${QtCore_location})

macro(_find_toonz_library OUT_LIB_LIST IN_LIB_LIST)
    set(OUTLIST "")
    foreach(arg ${IN_LIB_LIST})
        unset(COREPATH CACHE)
        # find しても cmake が走るときにはできていないので完全なパス名を生成して返すだけ
        if(BUILD_ENV_APPLE)
            set(LIBPATH "\$<TARGET_FILE:${arg}>")
        else()
            set(LIBPATH ${arg})
        endif()
        set(OUTLIST ${OUTLIST} ${LIBPATH})
    endforeach()
    set(${OUT_LIB_LIST} ${OUTLIST})
endmacro()

set(TNZSTDFX_Location)
set(TFARM_Location)

set(QT_LIB)  # avoid warning

if(BUILD_ENV_MSVC)
    set(MSVC_LIB_VERSION 2015)

    set(GLUT_LIB ${SDKROOT}/glut/3.7.6/lib/glut${PLATFORM}.lib)
    set(GL_LIB opengl32.lib)
    set(Z_LIB
        optimized ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    #set(JPEG_LIB ${SDKROOT}/LibJPEG/jpeg-9/lib/LibJPEG-9_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(JPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/jpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TURBOJPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/turbojpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TIFF_INCLUDE_DIR ${SDKROOT}/tiff-4.0.3/libtiff)
    set(TIFF_LIB
        optimized ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(PNG_LIB
        optimized ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(GLEW_LIB ${SDKROOT}/glew/glew-1.9.0/lib/glew${PLATFORM}.lib)
    set(LZ4_LIB ${SDKROOT}/Lz4/Lz4_131/lz4_${PLATFORM}.lib)
    set(SUPERLU_LIB ${SDKROOT}/superlu/SuperLU_${MSVC_LIB_VERSION}_${PLATFORM}.lib)
    set(OPENBLAS_LIB ${SDKROOT}/openblas/libopenblas_${PLATFORM}.lib)
    set(USB_LIB)  # unused
    
    if(PLATFORM EQUAL 32)
        set(QT_LIB ${SDKROOT}/quicktime/QT73SDK/Libraries/QTMLClient.lib)
    endif()
    set(MYPAINT_LIB_INCLUDE_DIRS ${SDKROOT}/libmypaint/dist/${PLATFORM}/include/libmypaint)
    set(MYPAINT_LIB_LDFLAGS ${SDKROOT}/libmypaint/dist/${PLATFORM}/libmypaint.lib)

    if(PLATFORM EQUAL 64)
        if (WITH_CANON)
            set(CANON_LIB ${SDKROOT}/canon/library/EDSDK.lib)
        endif()
    endif()
elseif(BUILD_ENV_APPLE)
    find_library(GLUT_LIB GLUT)
    find_library(GL_LIB OpenGL)
    find_library(Z_LIB z)

    find_package(TIFF REQUIRED)
    set(TIFF_LIB ${TIFF_LIBRARY})
    # the libraries have not .pc nor preferred Find*.cmake. use custom modules.
    find_package(PNG REQUIRED)
    message("******* libpng:" ${PNG_LIBRARY})
    set(PNG_LIB ${PNG_LIBRARY})
    find_package(GLEW)

    find_package(SuperLU REQUIRED)
    set(SUPERLU_INCLUDE_DIR ${SUPERLU_INCLUDE_DIR}/superlu)
    set(SUPERLU_LIB ${SUPERLU_LIBRARY})
    message("SuperLU:" ${SUPERLU_INCLUDE_DIR})

=== toonz/sources/image/CMakeLists.txt ===
set(HEADERS
    sgi/tiio_sgi.h
    pli/pli_io.h
    pli/tiio_pli.h
    tga/tiio_tga.h
    compatibility/inforegion.h
    compatibility/tfile_io.h
    compatibility/tnz4.h
    quantel/filequantel.h
    quantel/filequantelP.h
    quantel/tiio_quantel.h
    png/tiio_png.h
    psd/tiio_psd.h
    svg/tiio_svg.h
    tzl/tiio_tzl.h
    ../include/tnzimage.h
    mov/tiio_mov_proxy.h
    3gp/tiio_3gp_proxy.h
    ffmpeg/tiio_gif.h
    ffmpeg/tiio_webm.h
    ffmpeg/tiio_apng.h
    ffmpeg/tiio_mp4.h
    ffmpeg/tiio_ffmpeg.h
    ffmpeg/tiio_ff_mov.h
    sprite/tiio_sprite.h
    mesh/tiio_mesh.h
    exr/tinyexr_otmod.h
    exr/tiio_exr.h
)

set(SOURCES
    tiio.cpp
    sgi/filesgi.cpp
    pli/pli_io.cpp
    pli/tags.cpp
    pli/tiio_pli.cpp
    tga/tiio_tga.cpp
    compatibility/inforegion.c
    compatibility/tfile_io.c
    compatibility/tnz4.c
    compatibility/tnz4_cpp.cpp
    quantel/filequantel.c
    quantel/tiio_quantel.cpp
    png/tiio_png.cpp
    psd/tiio_psd.cpp
    svg/tiio_svg.cpp
    tzl/tiio_tzl.cpp
    mov/tiio_mov_proxy.cpp
    3gp/tiio_3gp_proxy.cpp
    ffmpeg/tiio_gif.cpp
    ffmpeg/tiio_webm.cpp
    ffmpeg/tiio_apng.cpp
    ffmpeg/tiio_mp4.cpp
    ffmpeg/tiio_ffmpeg.cpp
    ffmpeg/tiio_ff_mov.cpp
    sprite/tiio_sprite.cpp
    mesh/tiio_mesh.cpp
    exr/tiio_exr.cpp
)


# Can't build this on FreeBSD: libtiff requires internal API access.
# Probably some one get luck to fix this.
if(NOT BUILD_TARGET_BSD)
    set(HEADERS ${HEADERS}
        tif/tiio_tif.h
        tzp/tiio_plt.h
        tzp/tiio_tzp.h
        tzp/toonztags.h
    )
    set(SOURCES ${SOURCES}
        tif/tiio_tif.cpp
        tzp/tiio_plt.cpp
        tzp/tiio_tzp.cpp
        tzp/toonzrle.cpp
        tzp/avl.c
    )
endif()


if(BUILD_TARGET_WIN)
    set(HEADERS ${HEADERS}
        avi/tiio_avi.h
        mov/tiio_mov.h
        3gp/tiio_3gp.h
    )
    set(SOURCES ${SOURCES}
        avi/tiio_avi.cpp
        mov/tiio_movW.cpp
        3gp/tiio_3gpW.cpp
    )
elseif(BUILD_TARGET_APPLE)
    set(HEADERS ${HEADERS}
        mov/tiio_movM.h
        3gp/tiio_3gpM.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_movM.cpp
        3gp/tiio_3gpM.cpp
    )
elseif(BUILD_TARGET_UNIX)
    set(HEADERS ${HEADERS}
        3gp/tiio_3gp_proxy.h
        mov/tiio_mov_proxy.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_mov_proxy.cpp
        3gp/tiio_3gp_proxy.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(image ${HEADERS} ${SOURCES})
endif()

add_library(image SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -DTNZIMAGE_DLL
    -D_USRDLL
    -DIMAGE_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libimage.dylib")
    add_dependencies(image tnzcore tnzbase toonzlib)
endif()

message("subdir: image")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    SYSTEM
    ${TIFF_INCLUDE_DIR}
)

if(NOT BUILD_TARGET_BSD)
    include_directories(
        ${SDKROOT}/LibJPEG/jpeg-9
    )
endif()


if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/libpng-1.6.21
    )
endif()
if(BUILD_TARGET_WIN AND PLATFORM EQUAL 32)
    include_directories(
        SYSTEM
        ${SDKROOT}/quicktime/QT73SDK/CIncludes
    )
endif()

include_directories(
    ${SDKROOT}/tinyexr
)


_find_toonz_library(TNZLIBS "tnzcore;tnzbase;toonzlib")


if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS
        ${TNZLIBS}
        vfw32.lib
    )
elseif(BUILD_ENV_APPLE)
    if(PLATFORM EQUAL 32)
        find_library(CORE_SERVICES_LIB CoreServices)
        set(OSX_10_6_SDK_PATH "")
        if(NOT OSX_10_6_SDK_PATH)
            message(FATAL_ERROR "Set variable 'OSX_10_6_SDK_PATH'")
        endif()
        find_library(QD_LIB
            NAMES QD
            PATHS OSX10_6_SDK_PATH
        )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -F ${OSX_10_6_SDK_PATH}")
    endif()
    set(EXTRA_LIBS
        ${TNZLIBS}
        ${QT_LIB}
        ${CARBON_LIB}
        ${CORE_SERVICES_LIB}
        ${QD_LIB}
    )
elseif(BUILD_ENV_UNIXLIKE)
    # Generic Unix
    set(EXTRA_LIBS
        ${TNZLIBS}
    )

    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS ${EXTRA_LIBS} -lvfw32)
    endif()
endif()

target_link_libraries(image Qt5::Core Qt5::Gui Qt5::Network ${Z_LIB} ${GLUT_LIB} ${GL_LIB} ${JPEG_LIB} ${TIFF_LIB} ${PNG_LIB} ${EXTRA_LIBS})

=== toonz/sources/tnzcore/CMakeLists.txt ===
set(MOC_HEADERS
    ../include/tundo.h
    ../include/tthread.h
    ../common/tcore/tthreadp.h
    ../include/tipcsrv.h
    ../include/tipcsrvP.h
    ../include/tmsgcore.h
    ../include/tfunctorinvoker.h
)

set(HEADERS ${MOC_HEADERS}
    ../common/trop/loop_macros.h
    ../common/trop/optimize_for_lp64.h
    ../common/trop/quickputP.h
    ../common/tiio/compatibility/tfile_io.h
    ../common/tiio/bmp/filebmp.h
    ../include/movsettings.h
    ../include/tconst.h
    ../include/transparencycheck.h
    ../include/trastercm.h
    ../include/trasterfx.h
    ../include/ttile.h
    ../common/psdlib/psd.h
    ../common/psdlib/psdutils.h
    ../common/trop/runsmap.h
    ../common/tvectorimage/tvectorimageP.h
    ../common/tvectorimage/tsegmentadjuster.h
    ../common/tvectorimage/tl2lautocloser.h
    ../common/tvrender/tellipticbrushP.h
    ../include/tatomicvar.h
    ../include/tcommon.h
    ../include/tconvert.h
    ../include/tdata.h
    ../include/tdebugmessage.h
    ../include/texception.h
    ../include/texpression.h
    ../include/tmathutil.h
    ../include/tnztypes.h
    ../include/tproperty.h
    ../include/trandom.h
    ../include/tsmartpointer.h
    ../include/tstopwatch.h
    ../include/tthreadmessage.h
    ../include/tutil.h
    ../include/tcolorfunctions.h
    ../include/tcolorvalue.h
    ../include/tcolumnset.h
    ../include/tpixel.h
    ../include/tpixelcm.h
    ../include/tpixelgr.h
    ../include/tpixelutils.h
    ../include/tspectrum.h
    ../include/tcurves.h
    ../include/tcurveutil.h
    ../include/tgeometry.h
    ../include/traster.h
    ../include/timage.h
    ../include/tlevel.h
    ../include/tcontenthistory.h
    ../include/tfilepath.h
    ../include/tfilepath_io.h
    ../include/tfiletype.h
    ../include/timagecache.h
    ../include/tlogger.h
    ../include/tpluginmanager.h
    ../include/tsystem.h
    ../include/drawutil.h
    ../include/tregion.h
    ../include/tstroke.h
    ../include/tstrokeoutline.h
    ../include/tsweepboundary.h
    ../include/tvectorimage.h
    ../include/tgl.h
    ../include/tstencilcontrol.h
    ../include/tsop.h
    ../include/tsound.h
    ../include/tsound_io.h
    ../include/tsound_t.h
    ../include/tsoundsample.h
    ../include/timage_io.h
    ../include/timageinfo.h
    ../include/tlevel_io.h
    ../include/tcachedlevel.h
    ../include/tcodec.h
    ../include/trasterimage.h
    ../include/tcolorstyles.h
    ../include/tfont.h
    ../include/tinbetween.h
    ../include/tofflinegl.h
    ../include/qtofflinegl.h
    ../include/tpalette.h
    ../include/tpaletteutil.h
    ../include/tregionprop.h
    ../include/tsimplecolorstyles.h
    ../include/tstrokedeformations.h
    ../include/tstrokeprop.h
    ../include/tstrokeutil.h
    ../include/ttessellator.h
    ../include/tvectorgl.h
    ../include/tvectorbrushstyle.h
    ../include/tvectorrenderdata.h
    ../include/trop.h
    ../include/trop_borders.h
    ../include/tropcm.h
    ../include/tpersist.h
    ../include/tpersistset.h
    ../include/tstream.h
    ../include/tstreamexception.h
    ../include/tiio.h
    ../include/tiio_bmp.h
    ../include/tiio_jpg.h
    ../include/tiio_jpg_util.h
    ../include/tiio_jpg_exif.h
    ../include/tiio_std.h
    ../include/ttoonzimage.h
    ../include/tipc.h
    ../include/tipcmsg.h
    ../include/t32bitsrv_wrap.h
    ../include/tenv.h
    ../include/tmeshimage.h
    ../include/tgldisplaylistsmanager.h
    ../include/tversion.h
)

set(SOURCES
    ../common/tcore/tdata.cpp
    ../common/tcore/tdebugmessage.cpp
    ../common/tcore/texception.cpp
    ../common/tcore/threadmessage.cpp
    ../common/tcore/tmathutil.cpp
    ../common/tproperty.cpp
    ../common/tcore/trandom.cpp
    ../common/tcore/tsmartpointer.cpp
    ../common/tcore/tstopwatch.cpp
    ../common/tcore/tstring.cpp
    ../common/tcore/tthread.cpp
    ../common/tcore/tundo.cpp
    ../common/tcore/tfunctorinvoker.cpp
    ../common/tcolor/tcolorfunctions.cpp
    ../common/tcolor/tcolorvalue.cpp
    ../common/tcolor/tpixel.cpp
    ../common/tcolor/tpixelutils.cpp
    ../common/tcolor/tspectrum.cpp
    ../common/tgeometry/tcurves.cpp
    ../common/tgeometry/tcurveutil.cpp
    ../common/tgeometry/tgeometry.cpp
    ../common/traster/traster.cpp
    ../common/timage/timage.cpp
    ../common/timage/tlevel.cpp
    ../common/tsystem/cpuextensions.cpp
    ../common/tsystem/tbigmemorymanager.cpp
    ../common/tcontenthistory.cpp
    ../common/tsystem/tfilepath.cpp
    ../common/tsystem/tfilepath_io.cpp
    ../common/tsystem/tfiletype.cpp
    ../common/tcache/timagecache.cpp
    ../common/tsystem/tlogger.cpp
    ../common/tsystem/tpluginmanager.cpp
    ../common/tsystem/tsystem.cpp
    ../common/tvectorimage/cornerdetector.cpp
    ../common/tvectorimage/drawutil.cpp
    ../common/tvectorimage/tcomputeregions.cpp
    ../common/tvectorimage/tregion.cpp
    ../common/tvectorimage/tstroke.cpp
    ../common/tvectorimage/tstrokeoutline.cpp
    ../common/tvectorimage/tsegmentadjuster.cpp
    ../common/tvectorimage/tsweepboundary.cpp
    ../common/tvectorimage/tvectorimage.cpp
    ../common/tgl/tgl.cpp
    ../common/tgl/tstencilcontrol.cpp
    ../common/tgl/tgldisplaylistsmanager.cpp
    ../common/tsound/tsop.cpp
    ../common/tsound/tsound.cpp
    ../common/tsound/tsound_io.cpp
    ../common/timage_io/timage_io.cpp
    ../common/timage_io/tlevel_io.cpp
    ../common/trasterimage/tcodec.cpp
    ../common/trasterimage/trasterimage.cpp
    ../common/tvrender/tcolorstyles.cpp
    ../common/tvrender/tellipticbrush.cpp
    ../common/tvrender/qtofflinegl.cpp
    ../common/tvrender/tglcurves.cpp
    ../common/tvrender/tglregions.cpp
    ../common/tvrender/tinbetween.cpp
    ../common/tvrender/tofflinegl.cpp
    ../common/tvrender/tpalette.cpp
    ../common/tvrender/tpaletteutil.cpp
    ../common/tvrender/tregionprop.cpp
    ../common/tvrender/tsimplecolorstyles.cpp
    ../common/tvrender/tstrokedeformations.cpp
    ../common/tvrender/tstrokeprop.cpp
    ../common/tvrender/tstrokeutil.cpp
    ../common/tvrender/ttessellator.cpp
    ../common/tvrender/tvectorbrush.cpp
    ../common/tvrender/tvectorbrushstyle.cpp
    ../common/psdlib/psd.cpp
    ../common/psdlib/psdutils.cpp
    ../common/trop/bbox.cpp
    ../common/trop/brush.cpp
    ../common/trop/quickput.cpp
    ../common/trop/runsmap.cpp
    ../common/trop/tantialias.cpp
    ../common/trop/tblur.cpp
    ../common/trop/tcheckboard.cpp
    ../common/trop/tconvert.cpp
    ../common/trop/tconvolve.cpp
    ../common/trop/tdespeckle.cpp
    ../common/trop/tdistancetransform.cpp
    ../common/trop/terodilate.cpp
    ../common/trop/tinvert.cpp
    ../common/trop/toperators.cpp
    ../common/trop/tover.cpp
    ../common/trop/traylit.cpp
    ../common/trop/tresample.cpp
    ../common/trop/trgbmscale.cpp
    ../common/trop/trop.cpp
    ../common/trop/tropcm.cpp
    ../common/trop/trop_borders.cpp
    ../common/tstream/tstream.cpp
    ../common/tstream/tstreamexception.cpp
    ../common/tstream/tpersistset.cpp
    ../common/tiio/tiio.cpp
    ../common/tiio/tiio_bmp.cpp
    ../common/tiio/tiio_jpg.cpp
    ../common/tiio/tiio_jpg_util.cpp
    ../common/tiio/tiio_jpg_exif.cpp
    ../common/tiio/tiio_std.cpp
    ../common/tiio/movsettings.cpp
    ../common/tiio/compatibility/tfile_io.c
    ../common/tiio/bmp/filebmp.c
    ../common/trop/tfracmove.cpp
    ../common/ttoonzimage/ttonzimage.cpp
    ../common/tsystem/uncpath.cpp
    ../common/tvectorimage/tl2lautocloser.cpp
    ../common/tvectorimage/outlineApproximation.cpp
    ../common/tipc/tipc.cpp
    ../common/tipc/tipcmsg.cpp
    ../common/tipc/tipcsrv.cpp
    ../common/tipc/t32bitsrv_wrap.cpp
    ../common/tsystem/tsystempd.cpp
    ../common/tapptools/tenv.cpp
    ../common/tmeshimage/tmeshimage.cpp
    ../common/tmsgcore.cpp
    ../common/tvrender/tfont_qt.cpp
)

if(BUILD_TARGET_WIN)
    set(SOURCES ${SOURCES}
        ../common/tsound/tsound_nt.cpp
    )
elseif(BUILD_TARGET_APPLE)
    set(SOURCES ${SOURCES}
        ../common/tsound/tsound_qt.cpp
    )
elseif(BUILD_TARGET_UNIX)
    set(SOURCES ${SOURCES}
        ../common/tsound/tsound_qt.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(tnzcore ${HEADERS} ${SOURCES})
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

add_library(tnzcore SHARED ${HEADERS} ${SOURCES})

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtnzcore.dylib")
endif()

add_definitions(
    -DTNZCORE_EXPORTS
    -DTCOLOR_EXPORTS
    -DTGEOMETRY_EXPORTS
    -DTRASTER_EXPORTS
    -DTIMAGE_EXPORTS
    -DTSYSTEM_EXPORTS
    -DTVECTORIMAGE_EXPORTS
    -DTGL_EXPORTS
    -DTSOUND_EXPORTS
    -DTIMAGE_IO_EXPORTS
    -DTRASTERIMAGE_EXPORTS
    -DTVRENDER_EXPORTS
    -DTFLASH_EXPORTS
    -DTROP_EXPORTS
    -DTSTREAM_EXPORTS
)

if(BUILD_TARGET_WIN)
    add_definitions(
        -DUNICODE
        -D_UNICODE
    )
endif()

message("subdir: tnzcore")
#message("Sources:" ${SOURCES})

include_directories(
    SYSTEM
    ../common/flash
    ${SDKROOT}/Lz4/Lz4_131/lib/
)

if(BUILD_TARGET_WIN)
    if(PLATFORM EQUAL 32)
        include_directories(
            SYSTEM
            ${SDKROOT}/quicktime/QT73SDK/CIncludes
        )
    endif()
endif()


if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS
        netapi32.lib
        mpr.lib
        winmm.lib
        opengl32.lib
        glu32.lib
        dbghelp.lib
    )
elseif(BUILD_ENV_APPLE)
    find_library(AUDIOUNIT_LIB AudioUnit)
    find_library(AUDIOTB_LIB AudioToolbox)
    find_library(CARBON_LIB Carbon)

    set(EXTRA_LIBS
        ${AUDIOUNIT_LIB}
        ${AUDIOTB_LIB}
        ${CARBON_LIB}
    )
elseif(BUILD_ENV_UNIXLIKE)
    if(NOT BUILD_TARGET_WIN)
        include_directories(
            SYSTEM
            ${FREETYPE_INCLUDE_DIRS}
        )
    endif()
    set(EXTRA_LIBS
        ${GLU_LIB}
    )
    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS
            ${EXTRA_LIBS}
            -lnetapi32
            -lmpr
            -lwinmm
            -lpsapi
            -ldbghelp
        )
    endif()
endif()

target_link_libraries(tnzcore
    Qt5::Core Qt5::OpenGL Qt5::Network Qt5::Multimedia
    ${GL_LIB} ${GLUT_LIB} ${QT_LIB} ${Z_LIB} ${JPEG_LIB} ${LZ4_LIB}
    ${EXTRA_LIBS}
)

=== toonz/sources/tnztools/CMakeLists.txt ===
set(MOC_HEADERS
    controlpointselection.h
    edittoolgadgets.h
    filltool.h
    fullcolorbrushtool.h
    fullcolorfilltool.h
    plastictool.h
    skeletonsubtools.h
    tooloptionscontrols.h
    toonzrasterbrushtool.h
    viewtools.h
    selectiontool.h
    edittool.h
    controlpointeditortool.h
    geometrictool.h
    ../include/tools/imagegrouping.h
    ../include/tools/screenpicker.h
    ../include/tools/toolhandle.h
    ../include/tools/tooloptions.h
)

set(HEADERS
    ${MOC_HEADERS}
    autofill.h
    bluredbrush.h
    hookselection.h
    mypainttoonzbrush.h
    rasterselectiontool.h
    rgbpickertool.h
    rulertool.h
    setsaveboxtool.h
    shifttracetool.h
    stylepickertool.h
    toonzvectorbrushtool.h
    vectorselectiontool.h
    ../include/tools/RGBpicker.h
    ../include/tools/cursormanager.h
    ../include/tools/cursors.h
    ../include/tools/levelselection.h
    ../include/tools/rasterselection.h
    ../include/tools/strokeselection.h
    ../include/tools/stylepicker.h
    ../include/tools/tool.h
    ../include/tools/toolcommandids.h
    ../include/tools/toolutils.h
)

set(SOURCES
    autofillpli.cpp
    autofilltlv.cpp
    cursormanager.cpp
    stylepicker.cpp
    tool.cpp
    toolhandle.cpp
    toolutils.cpp
    bendertool.cpp
    bluredbrush.cpp
    controlpointeditortool.cpp
    cuttertool.cpp
    edittool.cpp
    edittoolgadgets.cpp
    filltool.cpp
    fullcolorbrushtool.cpp
    fullcolorerasertool.cpp
    fullcolorfilltool.cpp
    geometrictool.cpp
    hooktool.cpp
    hookselection.cpp
    imagegrouping.cpp
    irontool.cpp
    levelselection.cpp
    magnettool.cpp
    morphtool.cpp
    paintbrushtool.cpp
    pinchtool.cpp
    plastictool.cpp
    plastictool_animate.cpp
    plastictool_build.cpp
    plastictool_meshedit.cpp
    plastictool_rigidity.cpp
    pumptool.cpp
    rastererasertool.cpp
    rastertapetool.cpp
    rasterselectiontool.cpp
    rgbpickertool.cpp
    selectiontool.cpp
    setsaveboxtool.cpp
    skeletonsubtools.cpp
    skeletontool.cpp
    stylepickertool.cpp
    trackertool.cpp
    typetool.cpp
    tooloptionscontrols.cpp
    tooloptions.cpp
    vectorerasertool.cpp
    vectorselectiontool.cpp
    vectortapetool.cpp
    viewtools.cpp
    controlpointselection.cpp
    rasterselection.cpp
    strokeselection.cpp
    screenpicker.cpp
    fingertool.cpp
    rulertool.cpp
    mypainttoonzbrush.cpp
    shifttracetool.cpp
    toonzrasterbrushtool.cpp
	toonzvectorbrushtool.cpp
)

set(RESOURCES tnztools.qrc)

qt5_add_resources(SOURCES ${RESOURCES})

if(WITH_TRANSLATION)
    add_translation(tnztools ${HEADERS} ${SOURCES})
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

add_library(tnztools SHARED ${HEADERS} ${SOURCES} ${RESOURCES})
add_definitions(
    -DTNZTOOLS_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtnztools.dylib")
    add_dependencies(tnztools tnzcore tnzbase tnzext toonzlib toonzqt)
endif()

message("subdir: tnztools")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    SYSTEM
    ${SDKROOT}/superlu/SupperLU_4.1/SRC
)
include_directories(
    ../include/tools
)

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;tnzext;toonzlib;toonzqt")

target_link_libraries(tnztools Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Network Qt5::OpenGL ${GLUT_LIB} ${EXTRA_LIBS} ${GL_LIB} ${MYPAINT_LIB_LDFLAGS})

=== toonz/sources/toonz/CMakeLists.txt ===
set(VERSION 1.7.1)

set(MOC_HEADERS
    addfilmstripframespopup.h
    adjustlevelspopup.h
    adjustthicknesspopup.h
    antialiaspopup.h
    audiorecordingpopup.h
    autoinputcellnumberpopup.h
    batches.h
    batchserversviewer.h
    binarizepopup.h
    boardsettingspopup.h
    brightnessandcontrastpopup.h
    cachefxcommand.h
    camerasettingspopup.h
    canvassizepopup.h
    castviewer.h
    cleanuppaletteviewer.h
    cleanuppopup.h
    cleanuppreview.h
    cleanupsettingsmodel.h
    cleanupsettingspane.h
    cleanupsettingspopup.h
    cleanupswatch.h
    colormodelbehaviorpopup.h
    colormodelviewer.h
    comboviewerpane.h
    commandbar.h
    commandbarpopup.h
    convertpopup.h
    crashhandler.h
    duplicatepopup.h
    dvdirtreeview.h
    dvitemview.h
    dvwidgets.h
    exportlevelpopup.h
    exportpanel.h
    exportscenepopup.h
    filebrowser.h
    filebrowsermodel.h
    filebrowserpopup.h
    fileinfopopup.h
    filmstrip.h
    flipbook.h
    formatsettingspopups.h
    frameheadgadget.h
    fxparameditorpopup.h
    histogrampopup.h
    historypane.h
    imageviewer.h
    insertfxpopup.h
    layerfooterpanel.h
    layerheaderpanel.h
    levelcreatepopup.h
    levelsettingspopup.h
    linesfadepopup.h
    lipsyncpopup.h
    autolipsyncpopup.h
    loadfolderpopup.h
    locatorpopup.h
    magpiefileimportpopup.h
    mainwindow.h
    matchline.h
    menubar.h
    menubarpopup.h
    meshifypopup.h
    messagepanel.h
    ocaio.h
    onionskinmaskgui.h
    outputsettingspopup.h
    overwritepopup.h
    pane.h
    pltgizmopopup.h
    preferencespopup.h
    previewer.h
    previewfxmanager.h
    projectpopup.h
    psdsettingspopup.h
    reframepopup.h
    renumberpopup.h
    reslist.h
    ruler.h
    savepresetpopup.h
    scanpopup.h
    scenebrowser.h
    scenesettingspopup.h
    sceneviewer.h
    sceneviewercontextmenu.h
    scriptconsolepanel.h
    separatecolorspopup.h
    separatecolorsswatch.h
    shortcutpopup.h
    soundtrackexport.h
    startuppopup.h
    styleshortcutswitchablepanel.h
    svncleanupdialog.h
    svncommitdialog.h
    svndeletedialog.h
    svnlockdialog.h
    svnlockframerangedialog.h
    svnpurgedialog.h
    svnrevertdialog.h
    svnupdateandlockdialog.h
    svnupdatedialog.h
    tapp.h
    tasksviewer.h
    testpanel.h
    timestretchpopup.h
    toolbar.h
    tpanels.h
    trackerpopup.h
	vectorguideddrawingpane.h
    vectorizerpopup.h
    vectorizerswatch.h
    versioncontrol.h
    versioncontroltimeline.h
    versioncontrolwidget.h
    viewerpane.h
    xshcellviewer.h
    xshcolumnviewer.h
    xsheetviewer.h
    xshnoteviewer.h
    xshrowviewer.h
    xshtoolbar.h
	xdtsimportpopup.h
	expressionreferencemanager.h
    tooloptionsshortcutinvoker.h
    exportxsheetpdf.h
    custompanelmanager.h
    custompaneleditorpopup.h
    convertfolderpopup.h
    exportcameratrackpopup.h
)

if(PLATFORM EQUAL 64)
    set(MOC_HEADERS
        ${MOC_HEADERS}
        ../stopmotion/stopmotion.h
        ../stopmotion/stopmotioncontroller.h
        ../stopmotion/webcam.h
        ../stopmotion/jpgconverter.h
        ../stopmotion/canon.h
        ../stopmotion/stopmotionserial.h
        ../stopmotion/stopmotionlight.h
        cameracapturelevelcontrol.h
        penciltestpopup.h
        navtageditorpopup.h
    )
else()
    set(MOC_HEADERS
        ${MOC_HEADERS}
        cameracapturelevelcontrol_qt.h
        penciltestpopup_qt.h
        navtageditorpopup.h
    )
endif()

set(HEADERS
    ${MOC_HEADERS}
    celldata.h
    cellkeyframedata.h
    cellkeyframeselection.h
    cellselection.h
    columncommand.h
    columnselection.h
    curveio.h
    drawingdata.h
    exportlevelcommand.h
    filedata.h
    fileselection.h
    filmstripcommand.h
    filmstripselection.h
    floatingpanelcommand.h
    history.h
    iocommand.h
    keyframedata.h
    keyframemover.h
    keyframeselection.h
    kis_tablet_support_win8.h
    menubarcommandids.h
    moviegenerator.h
    scanlist.h
    sceneviewerevents.h
    selectionutils.h
    subcameramanager.h
    subscenecommand.h
    tfarmstuff.h
    versioncontrolgui.h
    versioncontrolxmlreader.h
    viewerdraw.h
    viewerpopup.h
    xshcellmover.h
    xsheetdragtool.h
    castselection.h
    ../include/cellposition.h
    ../include/orientation.h
    ../include/saveloadqsettings.h
    xdtsio.h
    levelcommand.h
# Tracker file
    ObjectTracker.h
    dummyprocessor.h
    metnum.h
    processor.h
    predict3d.h
    tvpjson_io.h
)

set(SOURCES
    floatingpanelcommand.cpp
    canvassizepopup.cpp
    commandbar.cpp
    commandbarpopup.cpp
    history.cpp
    loadfoldercommand.cpp
    loadfolderpopup.cpp
    main.cpp
    mainwindow.cpp
    matchline.cpp
    menubar.cpp
    menubarpopup.cpp
    mergecolumns.cpp
    moviegenerator.cpp
    pane.cpp
    previewer.cpp
    previewfxmanager.cpp
    ruler.cpp
    scanlist.cpp
    tapp.cpp
    toolbar.cpp
    batchserversviewer.cpp
    castviewer.cpp
    exportlevelpopup.cpp
    exportscenepopup.cpp
    colormodelviewer.cpp
    exportpanel.cpp
    filebrowser.cpp
    filebrowserversioncontrol.cpp
    filmstrip.cpp
    matchlinecommand.cpp
    messagepanel.cpp
    tasksviewer.cpp
    testpanel.cpp
    tpanels.cpp
    xshcellmover.cpp
    xshcellviewer.cpp
    xshcolumnviewer.cpp
    xsheetdragtool.cpp
    xsheetviewer.cpp
    xshnoteviewer.cpp
    xshrowviewer.cpp
    xshtoolbar.cpp
    sceneviewer.cpp
    sceneviewerevents.cpp
    viewerdraw.cpp
    viewerpane.cpp
    castselection.cpp
    cellselection.cpp
    columnselection.cpp
    fileselection.cpp
    filmstripselection.cpp
    keyframeselection.cpp
    addfilmstripframespopup.cpp
    camerasettingspopup.cpp
    convertpopup.cpp
    crashhandler.cpp
    duplicatepopup.cpp
    dvdirtreeview.cpp
    filebrowserpopup.cpp
    formatsettingspopups.cpp
    fxparameditorpopup.cpp
    histogrampopup.cpp
    insertfxpopup.cpp
    layerfooterpanel.cpp
    layerheaderpanel.cpp
    levelcreatepopup.cpp
    levelsettingspopup.cpp
    lipsyncpopup.cpp
    autolipsyncpopup.cpp
    magpiefileimportpopup.cpp
    outputsettingspopup.cpp
    overwritepopup.cpp
    pltgizmopopup.cpp
    preferencespopup.cpp
    projectpopup.cpp
    psdsettingspopup.cpp
    renumberpopup.cpp
    runscriptcommand.cpp
    savepresetpopup.cpp
    scanpopup.cpp
    scenebrowser.cpp
    scenebrowserversioncontrol.cpp
    sceneviewercontextmenu.cpp
    scenesettingspopup.cpp
    scriptconsolepanel.cpp
    shortcutpopup.cpp
    soundtrackexport.cpp
    startuppopup.cpp
    subcameramanager.cpp
    kis_tablet_support_win8.cpp
    timestretchpopup.cpp
    trackerpopup.cpp
    vectorguideddrawingpane.cpp
    vectorizerpopup.cpp
    vectorizerswatch.cpp
    versioncontrol.cpp
    versioncontroltimeline.cpp
    versioncontrolxmlreader.cpp
    versioncontrolwidget.cpp
    viewerpopup.cpp
    cellselectioncommand.cpp
    columncommand.cpp
    filmstripcommand.cpp
    iocommand.cpp
    levelcommand.cpp
    print.cpp
    subscenecommand.cpp
    svncleanupdialog.cpp
    svncommitdialog.cpp
    svndeletedialog.cpp
    svnlockdialog.cpp
    svnlockframerangedialog.cpp
    svnrevertdialog.cpp
    svnupdateandlockdialog.cpp
    svnupdatedialog.cpp
    svnpurgedialog.cpp
    vcrcommand.cpp
    xsheetcmd.cpp
    celldata.cpp
    drawingdata.cpp
    filedata.cpp
    imageviewer.cpp
    keyframedata.cpp
    dvitemview.cpp
    dvwidgets.cpp
    flipbook.cpp
    frameheadgadget.cpp
    onionskinmaskgui.cpp
    batches.cpp
    tfarmstuff.cpp
    cleanuppaletteviewer.cpp
    cleanuppopup.cpp
    cleanuppreview.cpp
    cleanupsettingsmodel.cpp
    cleanupsettingspopup.cpp
    cleanupswatch.cpp
    cellkeyframedata.cpp
    cellkeyframeselection.cpp
    keyframemover.cpp
    cachefxcommand.cpp
    exportlevelcommand.cpp
    adjustlevelspopup.cpp
    adjustthicknesspopup.cpp
    binarizepopup.cpp
    brightnessandcontrastpopup.cpp
    linesfadepopup.cpp
    rendercommand.cpp
    curveio.cpp
    meshifypopup.cpp
    selectionutils.cpp
    antialiaspopup.cpp
    mergecmapped.cpp
    comboviewerpane.cpp
    historypane.cpp
    cleanupsettingspane.cpp
    audiorecordingpopup.cpp
    locatorpopup.cpp
    styleshortcutswitchablepanel.cpp
	reframepopup.cpp
	autoinputcellnumberpopup.cpp
	colormodelbehaviorpopup.cpp
	boardsettingspopup.cpp
	separatecolorsswatch.cpp
	separatecolorspopup.cpp
    xdtsio.cpp
    ocaio.cpp
	xdtsimportpopup.cpp
	expressionreferencemanager.cpp
    tooloptionsshortcutinvoker.cpp
    tvpjson_io.cpp
    exportxsheetpdf.cpp
    custompanelmanager.cpp
    custompaneleditorpopup.cpp
    convertfolderpopup.cpp
    exportcameratrackpopup.cpp
# Tracker file
    dummyprocessor.cpp
    metnum.cpp
    ObjectTracker.cpp
    predict3d.cpp
)

if(PLATFORM EQUAL 64)
    set(SOURCES
        ${SOURCES}
        ../stopmotion/stopmotion.cpp
        ../stopmotion/stopmotioncontroller.cpp
        ../stopmotion/webcam.cpp
        ../stopmotion/jpgconverter.cpp
        ../stopmotion/canon.cpp
        ../stopmotion/stopmotionserial.cpp
        ../stopmotion/stopmotionlight.cpp
        cameracapturelevelcontrol.cpp
        penciltestpopup.cpp
        navtageditorpopup.cpp
    )
else()
    set(SOURCES
        ${SOURCES}
        cameracapturelevelcontrol_qt.cpp
        penciltestpopup_qt.cpp
        navtageditorpopup.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(toonz ${HEADERS} ${SOURCES})
endif()

set(OBJCSOURCES filebrowsermodel.cpp)

# Resource file(s)
set(RESOURCES toonz.qrc)

if(BUILD_ENV_MSVC)
    set(RC_FILE toonz.rc)
endif()

qt5_add_resources(SOURCES ${RESOURCES})

if(BUILD_ENV_APPLE)
    #set_source_files_properties(${OBJCSOURCES} PROPERTIES LANGUAGE OBJCXX)
    set_source_files_properties(${OBJCSOURCES} PROPERTIES COMPILE_FLAGS "-x objective-c++")
endif()

qt5_wrap_cpp(SOURCES ${MOC_HEADERS})

if(BUILD_ENV_MSVC)
    add_executable(OpenToonz WIN32 ${HEADERS} ${SOURCES} ${OBJCSOURCES} ${RESOURCES} ${RC_FILE})
else()
    set(MACOSX_BUNDLE_ICON_FILE "OpenToonz.icns")
    set_source_files_properties(OpenToonz.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(OpenToonz MACOSX_BUNDLE OpenToonz.icns ${HEADERS} ${SOURCES} ${OBJCSOURCES} ${RESOURCES})
    #add_definitions(
    #    -DTNZBASE_EXPORTS
    #    -DTPARAM_EXPORTS
    #    -DTXSHEET_EXPORTS
    #    -DTFX_EXPORTS
    #    -DTAPPTOOLS_EXPORTS
    #    -DTTEST_EXPORTS
    #)
endif()

if(BUILD_TARGET_WIN)
    add_definitions(
        -DUNICODE
        -D_UNICODE
    )
endif()

message("subdir: toonz")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})
#message("Lib: " ${LIBRARY_OUTPUT_PATH})
#message("Exe: " ${EXECUTABLE_OUTPUT_PATH})
#message("Sources:" ${SOURCES})

include_directories(
    ../../sources/toonzfarm/include
    ../../sources/toonzqt
    ../../sources/stopmotion
)

if (WITH_CANON)
    add_definitions(-DWITH_CANON)
endif()

if (WITH_WINTAB AND BUILD_TARGET_WIN AND (PLATFORM EQUAL 64))
    add_definitions(-DWITH_WINTAB)
endif()

if(BUILD_ENV_APPLE)
    include_directories(../../sources/mousedragfilter)
    if(PLATFORM EQUAL 64)
        include_directories(${TURBOJPEG_INCLUDE_DIRS})
    endif()
endif()

if(BUILD_TARGET_WIN)
    if(PLATFORM EQUAL 32)
        include_directories(
            SYSTEM
            ${SDKROOT}/quicktime/QT73SDK/CIncludes
        )
    endif()
endif()

if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS)
    if(PLATFORM EQUAL 64)
        set(EXTRA_LIBS ${EXTRA_LIBS} Qt5::SerialPort ${TURBOJPEG_LIB} ${OpenCV_LIBS})
        if(WITH_CANON)
            set(EXTRA_LIBS ${EXTRA_LIBS} ${CANON_LIB})
        endif()
    endif()
    target_link_libraries(OpenToonz
        Qt5::WinMain Qt5::Core Qt5::Gui Qt5::Network Qt5::OpenGL Qt5::Svg Qt5::Xml
        Qt5::Script Qt5::Widgets Qt5::PrintSupport Qt5::Multimedia Qt5::UiTools
        ${GL_LIB} ${GLUT_LIB} 
        ${EXTRA_LIBS} strmiids
        tnzcore tnzbase toonzlib colorfx tnzext image sound toonzqt tnztools tnzstdfx tfarm
    )
elseif(BUILD_ENV_APPLE)
    find_library(COCOA_LIB Cocoa)

=== thirdparty/superlu/SuperLU_4.1/EXAMPLE/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the example programs for the linear equation
#  routines in SuperLU.  The files are grouped as follows:
#
#       SLINEXM -- Single precision real example routines
#       DLINEXM -- Double precision real example routines
#       CLINEXM -- Double precision complex example routines
#       ZLINEXM -- Double precision complex example routines
#
#  Example programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single double
#  Alternatively, the command
#       make
#  without any arguments creates all four example programs.
#  The executable files are called
#       slinsol		slinsolx
#       dlinsol		dlinsolx
#       clinsol		clinsolx
#       zlinsol		zlinsolx
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

HEADER   = ../SRC

SLINEXM		= slinsol.o
SLINEXM1	= slinsol1.o
SLINXEXM 	= slinsolx.o
SLINXEXM1 	= slinsolx1.o
SLINXEXM2	= slinsolx2.o
SITSOL	     	= sitersol.o sfgmr.o

DLINEXM		= dlinsol.o
DLINEXM1	= dlinsol1.o
DLINXEXM 	= dlinsolx.o
DLINXEXM1 	= dlinsolx1.o
DLINXEXM2 	= dlinsolx2.o
SUPERLUEXM 	= superlu.o sp_ienv.o
DITSOL	     	= ditersol.o dfgmr.o

CLINEXM 	= clinsol.o
CLINEXM1 	= clinsol1.o
CLINXEXM 	= clinsolx.o
CLINXEXM1 	= clinsolx1.o
CLINXEXM2 	= clinsolx2.o
CITSOL	     	= citersol.o cfgmr.o

ZLINEXM 	= zlinsol.o
ZLINEXM1 	= zlinsol1.o
ZLINXEXM 	= zlinsolx.o
ZLINXEXM1 	= zlinsolx1.o
ZLINXEXM2 	= zlinsolx2.o
ZITSOL	     	= zitersol.o zfgmr.o


all:    single double complex complex16

single:    slinsol slinsol1 slinsolx slinsolx1 slinsolx2 sitersol
double:    dlinsol dlinsol1 dlinsolx dlinsolx1 dlinsolx2 superlu ditersol
complex:   clinsol clinsol1 clinsolx clinsolx1 clinsolx2 citersol
complex16: zlinsol zlinsol1 zlinsolx zlinsolx1 zlinsolx2 zitersol

slinsol: $(SLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINEXM) $(LIBS) -lm -o $@

slinsol1: $(SLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINEXM1) $(LIBS) -lm -o $@

slinsolx: $(SLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM) $(LIBS) -lm -o $@

slinsolx1: $(SLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM1) $(LIBS) -lm -o $@

slinsolx2: $(SLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM2) $(LIBS) -lm -o $@

sitersol: $(SITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SITSOL) $(LIBS) -lm -o $@

dlinsol: $(DLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINEXM) $(LIBS) -lm -o $@

dlinsol1: $(DLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINEXM1) $(LIBS) -lm -o $@

dlinsolx: $(DLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM) $(LIBS) -lm -o $@

dlinsolx1: $(DLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM1) $(LIBS) -lm -o $@

dlinsolx2: $(DLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM2) $(LIBS) -lm -o $@

superlu: $(SUPERLUEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SUPERLUEXM) $(LIBS) -lm -o $@

ditersol: $(DITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DITSOL) $(LIBS) -lm -o $@

clinsol: $(CLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINEXM) $(LIBS) -lm -o $@

clinsol1: $(CLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINEXM1) $(LIBS) -lm -o $@

clinsolx: $(CLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM) $(LIBS) -lm -o $@

clinsolx1: $(CLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM1) $(LIBS) -lm -o $@

clinsolx2: $(CLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM2) $(LIBS) -lm -o $@

citersol: $(CITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CITSOL) $(LIBS) -lm -o $@

zlinsol: $(ZLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINEXM) $(LIBS) -lm -o $@

zlinsol1: $(ZLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINEXM1) $(LIBS) -lm -o $@

zlinsolx: $(ZLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM) $(LIBS) -lm -o $@

zlinsolx1: $(ZLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM1) $(LIBS) -lm -o $@

zlinsolx2: $(ZLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM2) $(LIBS) -lm -o $@

zitersol: $(ZITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZITSOL) $(LIBS) -lm -o $@

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

clean:	
	rm -f *.o *linsol *linsol1 *linsolx *linsolx1 *linsolx2 \
	    superlu *itersol

=== thirdparty/superlu/SuperLU_4.1/FORTRAN/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the Fortran example interface to use the
#  C routines in SuperLU.
#######################################################################

HEADER   = ../SRC
LIBS	= $(SUPERLULIB) $(BLASLIB) -lm

F77EXM	= f77_main.o hbcode1.o c_fortran_dgssv.o

all:	f77exm

f77exm: $(F77EXM) $(SUPERLULIB)
	$(FORTRAN) $(LOADOPTS) $(F77EXM) $(LIBS) -o $@

c_fortran_zgssv.o: c_fortran_zgssv.c
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

clean:	
	rm -f *.o f77exm

=== thirdparty/superlu/SuperLU_4.1/MATLAB/Makefile ===
include ../make.inc

LUSRC   = ../SRC
HEADER	= -I$(LUSRC) -I$(MATLAB)/extern/include 
#
# For Matlab Version 4 compatibility: comment out -DV5, add -V4 in FFLAGS
FLAGS   = -O -DV5

all:            mexlusolve mexsuperlu

mexlusolve:	mexlusolve.c $(SUPERLULIB)
		${MATLAB}/bin/mex $(HEADER) ${FLAGS} mexlusolve.c \
		$(SUPERLULIB) $(BLASLIB) -lm

mexsuperlu:	mexsuperlu.c $(SUPERLULIB)
		${MATLAB}/bin/mex $(HEADER) ${FLAGS} mexsuperlu.c \
		$(SUPERLULIB) $(BLASLIB) -lm

clean:	
	rm -f *.o *.mex*

=== debian/changelog ===
opentoonz-dmo (1.7.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 10 May 2023 07:28:53 +0200

opentoonz-dmo (1.7.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 09 May 2023 08:44:44 +0200

opentoonz-dmo (1.6.0-dmo3) unstable; urgency=medium

  * Build with libglut3.12

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 06 Nov 2022 08:01:56 +0100

opentoonz-dmo (1.6.0-dmo2) unstable; urgency=medium

  * Build with opencv 4.6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Jul 2022 07:10:42 +0200

opentoonz-dmo (1.6.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 01 Apr 2022 08:30:51 +0200

opentoonz-dmo (1.5.0-dmo3) unstable; urgency=medium

  * Build with opencv 4.5d

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 26 Nov 2021 09:22:50 +0100

opentoonz-dmo (1.5.0-dmo2) unstable; urgency=medium

  * Build with libglew2.2

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 29 Sep 2021 23:51:29 +0200

=== debian/control ===
Source: opentoonz-dmo
Section: graphics
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://opentoonz.github.io/e/index.html
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), dh-sequence-scour, cmake, libboost-dev,
 qtbase5-dev, libqt5svg5-dev, qtscript5-dev, qttools5-dev, qttools5-dev,
 libqt5opengl5-dev, qtmultimedia5-dev, libsuperlu-dev, liblz4-dev, qtbase5-dev,
 libusb-1.0-0-dev, liblzo2-dev, libpng-dev, libjpeg-dev, libturbojpeg0-dev,
 freeglut3-dev (>= 3.4.0~), libsdl2-dev, libfreetype-dev, libopencv-dev,
 libmypaint-dev (>= 1:1.6.1~), libglew-dev (>= 2.2.0~), libqt5serialport5-dev,
 patchelf, ninja-build

Package: opentoonz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, opentoonz-data (= ${source:Version})
Description: full-featured 2D animation creation software
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.

Package: opentoonz-data
Architecture: all
Depends: ${misc:Depends}
Description: Open-source full-featured 2D animation creation software (data package)
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.
 .
 (This package contains the data files).

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

export DEB_CFLAGS_MAINT_APPEND = -fPIC

%:
	dh $@ -Dtoonz/sources -Bbuild -Scmake+ninja

override_dh_auto_configure:
	cd thirdparty/tiff-4.0.3 && \
	./configure --with-pic --disable-jbig

	$(MAKE) -C thirdparty/tiff-4.0.3 -j $(NCPUS)

	dh_auto_configure  -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE \
	-DCMAKE_SKIP_RPATH-ADVANCED=FALSE

#	exit 1

# Doesn't link against system libtiff
#	-DTIFF_LIBRARY:FILEPATH=/usr/lib/$(DEB_HOST_MULTIARCH)/libtiff.so

execute_after_dh_auto_install:
	patchelf --remove-rpath debian/tmp/usr/lib/opentoonz/*.so
	patchelf --remove-rpath debian/tmp/usr/bin/t*
	patchelf --remove-rpath debian/tmp/usr/bin/l*
	patchelf --remove-rpath debian/tmp/usr/bin/OpenToonz

override_dh_auto_clean:
	[ ! -f thirdparty/tiff-4.0.3/Makefile ] || $(MAKE) -C thirdparty/tiff-4.0.3 distclean

	dh_auto_clean

override_dh_clean:

	-rm -rf thirdparty/boost
	-rm -rf thirdparty/glew
	-rm -rf thirdparty/glut
	-rm -rf thirdparty/LibJPEG
	-rm -rf thirdparty/libmypaint
	-rm -rf thirdparty/libpng-*
	-rm -rf thirdparty/libusb
	-rm -rf thirdparty/Lz4
	-rm -rf thirdparty/openblas
	-rm -rf thirdparty/quicktime
	-rm -rf thirdparty/superlu
	-rm -rf thirdparty/zlib-*

	find -name *.exe -delete

	dh_clean

# Don't delete these directories
# thirdparty/kiss_fft130
# thirdparty/lzo
# thirdparty/tiff-4.0.3

override_dh_auto_test:
